#! /bin/sh

pidfile=${HOME}/.tunnel.pid
remote=foo@example.com
remote_port=2222
local_port=22

usage() {
    cat <<EOF
Usage:
$0 [ start | stop | restart | status ]
EOF
    
}

start() {
    ssh -a -c blowfish -f -N -T -x -R${remote_port}:localhost:${local_port} $remote &
    echo $! > $pidfile
    echo opening tunnel
}

stop() {
    kill -HUP `cat ${HOME}/.tunnel.pid`
    kill -CONT `cat ${HOME}/.tunnel.pid`
    echo closing tunnel
}

case "$1" in
    start)
        start
        break;;
    stop)
        stop
        break;;
    restart)
        stop
        start
        break;;
    status)
        ps axu | grep `cat ${HOME}/.tunnel.pid`
        break;;

    *)
        usage;
        break;;
esac